﻿function PVPSound_DataOnLoad()
	dataframe:RegisterEvent("CHAT_MSG_ADDON")
end

dataframe = CreateFrame("Frame", "PVPSound_DataFrame")

-- PVPSound Addon Data Sharing
function PVPSound_DataOnEvent(self, event, prefix, message, channel, sender)
	if PS_datashare == true then
		if event == "CHAT_MSG_ADDON" then
			-- If the Sent Data is from the registered prefix
			if prefix == "PVPSound" then
				-- If the sender is not nil and its not the player
				if sender ~= nil and sender ~= UnitName("player") then
					-- If the message is not nil
					if message ~= nil then
						-- Kill Data Share
						KSpree = tostring(message)
						if string.find(sender,"-") then
							-- If sender is from CrossRealm
							PlayerName = tostring(string.match(sender, "(.+)-"))
							if string.find(PlayerName,"-") then
								PlayerName = tostring(string.match(PlayerName, "(.+)-"))
								PVPSound_PrintKill(PlayerName, KSpree)
								PlayerName = nil
							else
								PVPSound_PrintKill(PlayerName, KSpree)
								PlayerName = nil
							end
						-- If the sender is not from CrossRealm and his/her Emote is toggled off or Emote is on but in Chat Message mode
						else
							PlayerName = tostring(sender)
							PVPSound_PrintKill(PlayerName, KSpree)
							PlayerName = nil
						end
						-- Death Data Share
						if string.find(message,":") then
							DSpree = tostring(string.match(message, "(.+):"))
							KillerNameServer = tostring(string.match(message, ":(.+)"))
							if KillerNameServer ~= nil then
								if string.find(KillerNameServer,"-") then
									KillerName = tostring(string.match(KillerNameServer, "(.+)-"))
									if string.find(KillerNameServer,"-") then
										KillerName = tostring(string.match(KillerNameServer, "(.+)-"))
									end
								else
									KillerName = tostring(KillerNameServer)
								end
								if DSpree ~= nil then
									if KillerName ~= nil and KillerName ~= UnitName("player") then
										if string.find(sender,"-") then
											SenderName = tostring(string.match(sender, "(.+)-"))
											if string.find(SenderName,"-") then
												SenderName = tostring(string.match(SenderName, "(.+)-"))
												PVPSound_PrintDeath(SenderName, DSpree, KillerName)
												KillerName = nil
											else
												PVPSound_PrintDeath(SenderName, DSpree, KillerName)
												KillerName = nil
											end
										else
											SenderName = tostring(sender)
											PVPSound_PrintDeath(SenderName, DSpree, KillerName)
											KillerName = nil
										end
									end
								end
							end
						else
							DSpree = nil
							KillerNameServer = nil
							KillerName = nil
						end
					end
				end
			end
		end
	end
end

local function PVPSound_PrintKill(sender, message)
	if sender ~= nil and message ~= nil then
		if message == "FirstBloodMale" then
			print("|cFFFFA500"..sender.." "..MSG_FirstBloodMale.."|cFFFFFFFF")
		elseif message == "FirstBloodFemale" then
			print("|cFFFFA500"..sender.." "..MSG_FirstBloodFemale.."|cFFFFFFFF")
		elseif message == "KillingSpree" then
			print("|cFFFFA500"..sender.." "..MSG_KillingSpree.."|cFFFFFFFF")
		elseif message == "Rampage" then
			print("|cFFFFA500"..sender.." "..MSG_Rampage.."|cFFFFFFFF")
		elseif message == "Dominating" then
			print("|cFFFFA500"..sender.." "..MSG_Dominating.."|cFFFFFFFF")
		elseif message == "Unstoppable" then
			print("|cFFFFA500"..sender.." "..MSG_Unstopable.."|cFFFFFFFF")
		elseif message == "Godlike" then
			print("|cFFFFA500"..sender.." "..MSG_Godlike.."|cFFFFFFFF")
		elseif message == "MASSACRE" then
			print("|cFFFFA500"..sender.." "..MSG_Massacre.."|cFFFFFFFF")
		elseif message == "FirstBloodMaleEmote" then
			print("|cFFFFA500"..sender.." "..MSG_FirstBloodMale.."|cFFFFFFFF")
		elseif message == "FirstBloodFemaleEmote" then
			print("|cFFFFA500"..sender.." "..MSG_FirstBloodFemale.."|cFFFFFFFF")
		elseif message == "KillingSpreeEmote" then
			print("|cFFFFA500"..sender.." "..MSG_KillingSpree.."|cFFFFFFFF")
		elseif message == "RampageEmote" then
			print("|cFFFFA500"..sender.." "..MSG_Rampage.."|cFFFFFFFF")
		elseif message == "DominatingEmote" then
			print("|cFFFFA500"..sender.." "..MSG_Dominating.."|cFFFFFFFF")
		elseif message == "UnstoppableEmote" then
			print("|cFFFFA500"..sender.." "..MSG_Unstopable.."|cFFFFFFFF")
		elseif message == "GodlikeEmote" then
			print("|cFFFFA500"..sender.." "..MSG_Godlike.."|cFFFFFFFF")
		elseif message == "MASSACREEmote" then
			print("|cFFFFA500"..sender.." "..MSG_Massacre.."|cFFFFFFFF")
		end
	end
end

local function PVPSound_PrintDeath(sender, message, killer)
	if sender ~= nil and message ~= nil and killer ~= nil then
		if message == "First Blood" then
			print("|cFFFF4500"..sender..""..MSG_FirstBlood_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "Killing Spree" then
			print("|cFFFF4500"..sender..""..MSG_KillingSpree_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "Rampage" then
			print("|cFFFF4500"..sender..""..MSG_Rampage_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "Dominating" then
			print("|cFFFF4500"..sender..""..MSG_Dominating_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "Unstoppable" then
			print("|cFFFF4500"..sender..""..MSG_Unstoppable_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "Godlike" then
			print("|cFFFF4500"..sender..""..MSG_Godlike_Over.." "..killer..".|cFFFFFFFF")
		elseif message == "MASSACRE" then
			print("|cFFFF4500"..sender..""..MSG_Massacre_Over.." "..killer..".|cFFFFFFFF")
		end
	end
end

dataframe:SetScript("OnEvent", PVPSound_DataOnEvent)